	IFND DYNAMITE_I
DYNAMITE_I	SET	1

;	Assembler includes for dynamite bot developers
;	Created by Ilkka Lehtoranta 3-Jun-2001
;			   updated 10-jun-2001

PA_NONE		EQU	0	; no player
PA_VISI		EQU	1	; visitor
PA_LOGGEDIN	EQU	2	; just logged in/after a game
PA_PLAYING	EQU	3	; is in game (no matter if he's dead)
PA_COUNTDOWN	EQU	4	; this is of no use. players only have this status if they logged in.
PA_DEAD		EQU	5	; this is of no use, it's not meant to see if a player is actually dead.
				; use player.dead instead. it's only set after successfull login for
				; other players
PA_WON		EQU	6	; a player has this status if he won the last round

GAME_CLOSEGAME  EQU 0		; transitional state to GAME_MENU after connection got closed
GAME_MENU       EQU 1		; game is in menu eg: login screen
GAME_ENDGAME    EQU 2		; transitional state to GAME_MENU after effect has been drawn
GAME_EFFECT     EQU 3		; game draws effect after a match
GAME_COUNTDOWN  EQU 4		; game is doing countdown
GAME_GAME       EQU 5		; game is running
GAME_HURRYUP    EQU 6		; game is running and is in hurry up mode

DIR_NONE		EQU	-1
DIR_DOWN		EQU	0
DIR_RIGHT		EQU	1
DIR_LEFT		EQU	2
DIR_UP			EQU	3

SPEED_NORMAL		EQU	4
SPEED_SLOW		EQU	3
SPEED_FAST		EQU	6

BLOCK_FAKEBLOCK		EQU	-1	; used for remote/kick bombs which are placed into the map
BLOCK_NOBLOCK		EQU	0	; empty field
BLOCK_HARDBLOCK		EQU	1	; non-destroyable block
BLOCK_DESTROYABLE	EQU	2	; normal block
BLOCK_BOMB		EQU	3	; normal bomb
BLOCK_BORDERWALL1	EQU	4	; borderblocks are equal to hardblock
BLOCK_BORDERWALL2	EQU	5
BLOCK_BORDERWALL3	EQU	6
BLOCK_BORDERWALL4	EQU	7
BLOCK_BORDERWALL5	EQU	8
BLOCK_BORDERWALL6	EQU	9
BLOCK_ADDBOMB		EQU	19	; block which contains a bomb

BO_EXPANDFLAME		EQU	1	; types for bonusgrid
BO_ADDBOMB		EQU	2
BO_FLAMEMAX		EQU	3
BO_BOMBMAX		EQU	4
BO_RANDOMWALL		EQU	5
BO_BOMBS2BLOCKS		EQU	6
BO_DROPALL		EQU	7
BO_EXPLALL		EQU	8
BO_FASTER		EQU	9
BO_SLOWER		EQU	10
BO_SHORTERFUSE		EQU	11
BO_LONGERFUSE		EQU	12
BO_SHORTERFLAME		EQU	13
BO_SWAPCONTROLSLR	EQU	14
BO_FEWERBOMBS		EQU	15
BO_NODROP		EQU	16
BO_SHIELD		EQU	17
BO_STANDSTILL		EQU	18
BO_TELEPORT		EQU	19
BO_REMOTEBOMB		EQU	20
BO_BACK2BASIC		EQU	21
BO_KICKBOMB		EQU	22
BO_SABER		EQU	23
BO_SWAPCONTROLSUD	EQU	24
BO_MAGNET		EQU	25
BO_PHOENIX		EQU	26
BO_DOHURRYUP		EQU	27
BO_INVISIBLE		EQU	28
BO_DUELL		EQU	29
BO_AFTERBURNER		EQU	30

BOMB_NORMAL	EQU	0	; normal bomb
BOMB_GEN	EQU	1	; predefined bomb (map)
BOMB_REMOTE	EQU	2	; remote bomb
BOMB_KICK	EQU	3	; kick bomb


	STRUCTURE ServerData,0
	STRUCT	sd_ServerName,34
	STRUCT	sd_SysOpName,18
	WORD	sd_MaxSlots
	WORD	sd_MaxObservers
	LABEL	ServerData_SIZEOF

	STRUCTURE TempBomb,0
	STRUCT	bmb_Node,MLN_SIZE
	WORD	bmb_BlockX
	WORD	bmb_BlockY
	WORD	bmb_PixelX
	WORD	bmb_PixelY
	WORD	bmb_Fuse		; >0 bomb is still ticking; =0 bomb is going to explode
	WORD	bmb_Range
	WORD	bmb_Direction		; kick/remote bombs
	WORD	bmb_OriginX
	WORD	bmb_OriginY
	WORD	bmb_Type		; is set to one of BOMB_#?
	LABEL	TempBomb_SIZEOF

	STRUCTURE Player,0
	WORD	plr_Player
	LONG	plr_Status
	WORD	plr_Dead		; >0 is alive
	WORD	plr_PixelX		; xpos + border (24 pixel)
	WORD	plr_PixelY		; ypos + border (16 pixel)
	WORD	plr_BlockX		; sijainti
	WORD	plr_BlockY

	WORD	plr_BombCount		; bombs going to explode
	WORD	plr_KickBombs

	APTR	plr_BombListHeader	; -> MLH
	APTR	plr_RemoteBomb		; -> Bomb
	APTR	plr_KickBomb		; -> Bomb

	WORD	plr_MaxRange		; 2-15
	WORD	plr_MaxBombs
	WORD	plr_FuseLength
	WORD	plr_Speed		; player speed; SPEED_NORMAL=4, SPEED_SLOW=3, SPEED_FAST=6
	WORD	plr_SpeedC		; >0 = player has other speed (SPEED_SLOW, SPEED_FAST)

	WORD	plr_SwapHoriz		; >0 = swaped horizontal controls
	WORD	plr_SwapVert
	WORD	plr_NoDrop

	WORD	plr_ShieldCount
	WORD	plr_StandStillCount
	WORD	plr_InvisibleCount
	WORD	plr_AfrerBurnerCount
	WORD	plr_b2bc

	WORD	plr_FlameThrowerCount
	WORD	plr_FlameThrowerDir
	WORD	plr_FlameThrowerRange	; 0-4

	WORD	plr_MagnetCount
	WORD	plr_MagnetDir

	STRUCT	plr_Name,34
	STRUCT	plr_System,64
	LABEL	Player_SIZEOF

	STRUCTURE dynSemaphore,0
	STRUCT	ds_Semaphore,SS_SIZE	; embedded signalsemaphore
	LONG	ds_OpenCnt
	LONG	ds_Quit
	LONG	ds_GameRunning		; >0 game running
	LONG	ds_Frames
	LONG	ds_Walk
	LONG	ds_Drop
	LONG	ds_DropKick
	LONG	ds_PlayerNum		; 0-15
	APTR	ds_Players		; array to players (0-15)
	LONG	ds_MapWidth
	LONG	ds_MapHeight
	APTR	ds_Grid			; array ptr to the actual map (29 entries max). each entry contains 1 line of the map without powerups
	APTR	ds_BonusGrid
	STRUCT	ds_AddBubble,10
	APTR	ds_ServerData		; see serverdata for details
	LABEL	dynSemaphore_SIZEOF

	ENDC	; DYNAMITE_I